public class IsAPalindrome implements WordFeature
{
  public IsAPalindrome()
  {
    // ... no data to initialize
  }

  public boolean hasFeature( String s )
  {
    if ( s == null || s.length() == 0 )
      return false;
    
    int length = s.length();
    if ( length < 2 )           // to exclude 1-letter words,
      return true;              // return false instead
    
    int half = length/2;
    for ( int i = 0; i < half; ++i )
      if ( s.charAt(i) != s.charAt(length - 1 - i) )
        return false;
    
    return true;
  }
}